#include "Board.hpp"

Board::Board( int pSideSize )
: sideSize( pSideSize ),
  rows( new int[ pSideSize ] ),
  rowsAttacked( new boolean[ pSideSize ] ),
  diagsAttacked( new boolean[ 2 * pSideSize - 1 ] ),
  antiDiagsAttacked( new boolean[ 2 * pSideSize - 1 ] )
///////////////////////////////////////////////////////
{
  // Initialize.
  for ( int i = 0; i < sideSize; i++ )
  {
    rows[ i ] = -1;             // no allocations
    rowsAttacked[ i ] = false;  // no row attacked
  }

  for ( i = 0; i < (2 * pSideSize - 1); i++ )
  {
    diagsAttacked[ i ] = false;  // no diag attacked
    antiDiagsAttacked[ i ] = false;  // no antiDiag attacked
  }
}


Board::~Board()
///////////////
{
  delete [] rows;               rows = NULL;
  delete [] rowsAttacked;       rowsAttacked = NULL;
  delete [] diagsAttacked;      diagsAttacked = NULL;
  delete [] antiDiagsAttacked;  antiDiagsAttacked = NULL;
}

