typedef int boolean;
#define true 1
#define false 0
#define NULL 0

class Board
///////////
{
private:
  int       sideSize;
  int*      rows;
  boolean*  rowsAttacked;
  boolean*  diagsAttacked;
  boolean*  antiDiagsAttacked;

public:

  Board( int pSideSize );
  //////////////////////

  ~Board();
  ////////

  boolean isAttacked( int row, int col )
  //////////////////////////////////////
  {
    return  rowsAttacked[ row ] ||
    diagsAttacked[ col + row ] ||
    antiDiagsAttacked[ col - row + sideSize - 1 ];
  }


  int getQueenRow( int col )
  //////////////////////////
  {
    return rows[ col ];
  }


  void setQueenRow( int col, int row )
  ////////////////////////////////////
  {
    // Restore values
    if ( rows[ col ] != -1 )
    {
      rowsAttacked[ rows[ col ] ] = false;
      diagsAttacked[ col + rows[ col ] ] = false;
      antiDiagsAttacked[ col - rows[ col ] + sideSize - 1 ] = false;
    }

    rows[ col ] = row;
    rowsAttacked[ row ] = true;
    diagsAttacked[ col + row ] = true;
    antiDiagsAttacked[ col - row + sideSize - 1 ] = true;
  }


  void cleanQueenCol( int col )
  /////////////////////////////
  {
    if ( rows[ col ] != -1 )
    {
      rowsAttacked[ rows[ col ] ] = false;
      diagsAttacked[ col + rows[ col ] ] = false;
      antiDiagsAttacked[ col - rows[ col ] + sideSize - 1 ] = false;
      rows[ col ] = -1;
    }
  }


  int getSideSize() 
  /////////////////
  {
    return sideSize;
  }

}; // class Board

